/*
Copyright (C) 1995 M. A. S. Elmohamed,
Northeast Parallel Architectures Center, Syracuse University.
saleh@npac.syr.edu
*/


#ifndef DEFINED_ARSCHED_H
#define DEFINED_ARSCHED_H

/* **********************************************************************/
/* ANSI -- because we were too lazy to lint */
#ifndef _PARAMS
#if defined(ANSI) || defined(_ANSI_) || defined(__STDC__)
#define _PARAMS(args) args
#else
#define _PARAMS(args) ()
#endif
#endif /* _PARAMS */

#ifndef _K_AND_R_C_
#if !(defined(ANSI) || defined(_ANSI_) || defined(__STDC__))
#define _K_AND_R_C_
#define void
#endif
#endif /* _K_AND_R_C_ */
/* **********************************************************************/

char *build_config_filename _PARAMS((char *directoryp));

tga_t load_thesis_groups_info_file _PARAMS((FILE *fp, char *filename,
				   pia_t students_pia,
				   pia_t professors_pia));

pia_t load_person_info_file _PARAMS((FILE *fp, char *filename));

fta_t load_time_slots_info_file _PARAMS((FILE *fp, char *filename));

void sort_person_time_info _PARAMS((pia_t pia, char *filename));

void sort_time_slots_time_info _PARAMS((fta_t fta, char *filename));

void create_restricted_schedule _PARAMS((pia_t stud_pia,pia_t prof_pia,
				       fta_t slot_fta, tga_t tga));

void reset_solution_set _PARAMS((pia_t stud_pia));
int choose_index _PARAMS((fta_t fta));
int fix_schedule_point _PARAMS((pia_t stud_pia,tga_t tga,pi_t pi,ft_t ft));
void brute_force_solve _PARAMS((FILE *fp, int print_all_results, 
				pia_t stud_pia, fta_t slot_fta,tga_t tga,
				int max_iters, 
				int nrooms, int room_idle_time));
int room_idle_check _PARAMS((pia_t stud_pia, fta_t slot_fta, int *pnum,
			     int *cnum, 
			     int number_of_rooms, int room_idle_time));

#endif /* DEFINED_ARSCHED_H */
