/*
Copyright (C) 1995 M. A. S. Elmohamed,
Northeast Parallel Architectures Center, Syracuse University.
saleh@npac.syr.edu
*/


#ifndef DEFINED_MISC_H
#define DEFINED_MISC_H

/* **********************************************************************/
/* ANSI -- because we were too lazy to lint */
#ifndef _PARAMS
#if defined(ANSI) || defined(_ANSI_) || defined(__STDC__)
#define _PARAMS(args) args
#else
#define _PARAMS(args) ()
#endif
#endif /* _PARAMS */

#ifndef _K_AND_R_C_
#if !(defined(ANSI) || defined(_ANSI_) || defined(__STDC__))
#define _K_AND_R_C_
#define void
#endif
#endif /* _K_AND_R_C_ */
/* **********************************************************************/

#ifdef MSDOS
int strcasecmp _PARAMS((char *s1, char *s2));
#endif

#define xfclose(s)	fclose(s)

char *xmalloc _PARAMS((unsigned int size));
char *xcalloc _PARAMS((unsigned int nelem, unsigned int elsize));
char *xrealloc _PARAMS((char *ptr, unsigned int size));
void xfree _PARAMS((char *ptr));

char *build_path _PARAMS((char *directory,char *filename));
char *basename _PARAMS((char *path, char *suffix, char *string));
FILE *xfopen _PARAMS((char *file, char *mode));
int xopen _PARAMS((char *file, int flags, int mode));

char *getline _PARAMS((char *buf, int len, FILE *fp));
char *string_parsetoken _PARAMS((char *buf, int *point, 
				 char *string, char sep));
char *string_parse_ws_separated_token _PARAMS((char *buf, int *point,
					       char *string));
char **split_line _PARAMS((char **field, char *line, int *nfields, char sep));
char **split_ws_separated_line _PARAMS((char **field, char *line, 
					int *nfields));
void free_fields _PARAMS((char **field, int nfields));

char *uppercase _PARAMS((char *buf));
char *lowercase _PARAMS((char *buf));
char *rm_ws _PARAMS((char *buf));
char *rm_lead_ws _PARAMS((char *buf));
char *rm_trail_ws _PARAMS((char *buf));
char *rm_lead_trail_ws _PARAMS((char *buf));

#endif /* DEFINED_MISC_H */
