/*
Copyright (C) 1995 M. A. S. Elmohamed,
Northeast Parallel Architectures Center, Syracuse University.
saleh@npac.syr.edu
*/

#ifndef DEFINED_ST_H
#define DEFINED_ST_H

/* **********************************************************************/
/* ANSI -- because we were too lazy to lint */
#ifndef _PARAMS
#if defined(ANSI) || defined(_ANSI_) || defined(__STDC__)
#define _PARAMS(args) args
#else
#define _PARAMS(args) ()
#endif
#endif /* _PARAMS */

#ifndef _K_AND_R_C_
#if !(defined(ANSI) || defined(_ANSI_) || defined(__STDC__))
#define _K_AND_R_C_
#define void
#endif
#endif /* _K_AND_R_C_ */
/* **********************************************************************/

#define STA_INCREMENT	5	/* re-allocation increment */

typedef struct st_struc {
  char *name;			/* name of owner of this slot */
  ft_t ft;			/* the owners slot */
} st_s, *st_t;

typedef struct sta_struc {
  st_t *st;			/* string/time data array */
  int nst;			/* number of items in array */
  int nst_limit;		/* maximum number that will fit in array */
} sta_s, *sta_t;

st_t st_create _PARAMS((char *name, ft_t ft));
void st_destroy _PARAMS((st_t st));

sta_t sta_create _PARAMS((void));
void sta_time_sort _PARAMS((sta_t sta));
#define sta_getlength(sta) 		(sta->nst)
#define sta_getst_array(sta)		(sta->st)
st_t sta_add _PARAMS((sta_t sta, char *name, ft_t ft));
void sta_destroy _PARAMS((sta_t sta));

#endif /* DEFINED_ST_H */
