/*
Copyright (C) 1995 M. A. S. Elmohamed,
Northeast Parallel Architectures Center, Syracuse University.
saleh@npac.syr.edu
*/

#ifndef DEFINED_TG_H
#define DEFINED_TG_H

/* **********************************************************************/
/* ANSI -- because we were too lazy to lint */
#ifndef _PARAMS
#if defined(ANSI) || defined(_ANSI_) || defined(__STDC__)
#define _PARAMS(args) args
#else
#define _PARAMS(args) ()
#endif
#endif /* _PARAMS */

#ifndef _K_AND_R_C_
#if !(defined(ANSI) || defined(_ANSI_) || defined(__STDC__))
#define _K_AND_R_C_
#define void
#endif
#endif /* _K_AND_R_C_ */
/* **********************************************************************/

#define TGA_INCREMENT	25	/* re-allocation increment */
#define GMA_INCREMENT	3	/* re-allocation increment */

/* The thesis group memebers datum */
typedef char gm_s, *gm_t;

/* The thesis group members array */
typedef struct gma_struc {
  gm_t *gm;			/* members */
  int ngm;			/* number of members in array */
  int ngm_limit;		/* maximum number that will fit in array */
} gma_s, *gma_t;

/* The thesis group datum */
typedef struct tg_struct {
  gma_t gma;			/* array of thesis group members */
} tg_s, *tg_t;

/* The thesis group array */
typedef struct tga_struc {
  tg_t *tg;			/* info data array */
  int ntg;			/* number of pieces of data in array */
  int ntg_limit;	
} tga_s, *tga_t;

#define gma_getlength(gma) (gma->ngm - 1)
gma_t gma_create _PARAMS((void));
char *gma_add_member _PARAMS((gma_t gma, char *member));
#define gma_getmember(gma,ix)		(gma->gm[ix])
#define gma_getgm_elt(gma,ix)		gma_getmember(gma,(ix+1))
#define gma_getgm_array(gma)		(&(gma->gm[1]))

tg_t tg_create _PARAMS((char *name));
#define tg_getname(tg)			(gma_getmember(tg->gma,0))
#define tga_gettg_array(tga)		(tga->tg)
#define tga_gettg_elt(tga,i)		(tga->tg[i])
gma_t tg_add_professor _PARAMS((tg_t tg, char *name));
gma_t tg_find_student _PARAMS((tg_t tg, char *name));
gma_t tg_find_professor _PARAMS((tg_t tg, char *name));
#define tg_getgma(tg)			(tg->gma)
#define tga_getlength(tga) (tga->ntg)
tga_t tga_create _PARAMS((void));
tg_t tga_add_student _PARAMS((tga_t tga, char *name));
tg_t tga_find_student _PARAMS((tga_t tga, char *name));
tg_t tga_find_professor _PARAMS((tga_t tga, char *name));
void tga_sort _PARAMS((tga_t tga));

#endif /* DEFINED_TG_H */
